Index: trunk/gsdl/macros/english2.dm
===================================================================
--- trunk/gsdl/macros/english2.dm	(revision 2779)
+++ trunk/gsdl/macros/english2.dm	(revision 2780)
@@ -871,2 +871,48 @@
 #------------------------------------------------------------
 
+
+_textframebrowser_ {You must have a frame enabled browser to view this.}
+_textusermanage_ {User management}
+_textlistusers_ {list users}
+_textaddusers_ {add a new user}
+_textchangepasswd_ {change password}
+_textinfo_ {Technical information}
+_textgeneral_ {general}
+_textarguments_ {arguments}
+_textactions_ {actions}
+_textbrowsers_ {browsers}
+_textprotocols_ {protocols}
+_textconfigfiles_ {Configuration files}
+_textlogs_ {Logs}
+_textusagelog_ {usage log}
+_textinitlog_ {init log}
+_texterrorlog_ {error log}
+_textadminhome_ {admin home}
+_textreturnhome_ {Greenstone home}
+_titlewelcome_ { Administration }
+_textmaas_ {Maintenance and administration services available include:}
+_textvol_ {view on-line logs}
+_textcmuc_ {create, maintain and update collections}
+_textati_ {access technical information such as CGI arguments}
+
+_texttsaa_ {
+These services are accessed using the side navigation bar on the lefthand
+side of the page.
+}
+
+_textcolstat_ {Collection Status}
+
+_textcwoa_ {
+Collections will only appear as &quot;running&quot; if their build.cfg
+files exist, are readable, contain a valid builddate field (i.e. > 0),
+and are in the collection's index directory (i.e. NOT the building
+directory).
+}
+
+_textcafi_ {click <i>abbrev.</i> for information on a collection}
+_textcctv_ {click <i>collection</i> to view a collection}
+_textsubc_ {Submit Changes}
+_texteom_ {Error opening main.cfg}
+_textftum_ {Failed to update main.cfg}
+_textmus_ {main.cfg updated successfully}
+
Index: trunk/gsdl/macros/status.dm
===================================================================
--- trunk/gsdl/macros/status.dm	(revision 2779)
+++ trunk/gsdl/macros/status.dm	(revision 2780)
@@ -88,58 +88,28 @@
 }
 
-
-_textframebrowser_ {You must have a frame enabled browser to view this.}
-_textusermanage_ {User management}
-_textlistusers_ {list users}
-_textaddusers_ {add a new user}
-_textchangepasswd_ {change password}
-
-_textinfo_ {Technical information}
-_textgeneral_ {general}
-_textarguments_ {arguments}
-_textactions_ {actions}
-_textbrowsers_ {browsers}
-_textprotocols_ {protocols}
-
-_textconfigfiles_ {Configuration files}
 _textgsdlsite_ {gsdlsite.cfg}
 _textmaincfg_ {main.cfg}
 
-_textlogs_ {Logs}
-_textusagelog_ {usage log}
-_textinitlog_ {init log}
-_texterrorlog_ {error log}
-
-_textadminhome_ {admin home}
-_textreturnhome_ {Greenstone home}
-
-_titlewelcome_ { Administration }
-
 _welcome_ {
-
 <center>
 <table width=_pagewidth_><tr><td>
-Maintenance and administration services available include:
+_textmaas_
 <ul>
-<li>view on-line logs
-<li>create, maintain and update collections
-<li>access technical information such as CGI arguments
+<li>_textvol_
+<li>_textcmuc_
+<li>_textati_
 </ul>
-These services are accessed using the side navigation bar on the
-lefthand side of the page.
+_texttsaa_
 <p>
 _iconblankbar_
 </td></tr>
-<tr><th align=left><br>Collection Status</th></tr>
+<tr><th align=left><br>_textcolstat_</th></tr>
 <tr><td>
 <font color=gray>
-Collections will only appear as &quot;running&quot; if their build.cfg
-files exist, are readable, contain a valid builddate field (i.e. > 0),
-and are in the collection's index directory (i.e. NOT the building
-directory).
+_textcwoa_
 <p>
-click <i>abbrev.</i> for information on a collection
+_textcafi_
 <br>
-click <i>collection</i> to view a collection
+_textcctv_
 </font>
 </td></tr>
@@ -155,6 +125,5 @@
 _maincfgfile_
 </textarea>
-<br><input type=submit value="Submit Changes"><input type=reset>,
-Error opening main.cfg)
+<br><input type=submit value="_textsubc_"><input type=reset>,_texteom_)
 </form>
 }
@@ -163,5 +132,5 @@
 <html>
 <body bgcolor="\#ffffff" text="\#000000">
-Failed to update main.cfg
+_textftum_
 _footer_
 }
@@ -170,6 +139,5 @@
 <html>
 <body bgcolor="\#ffffff" text="\#000000">
-main.cfg updated successfully
+_textmus_
 _footer_
 }
-